////////////////////////////////////////////////////////////////////////////////
//
//  ALLJOYN MODELING TOOL - GENERATED CODE
//
//  This is an autogenerated or copied file which Qualcomm Innovation Center,
//  Inc., as author hereby dedicates to the public domain.  Additionally, THIS
//  SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND ANY CONTRIBUTORS "AS IS"
//  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
//  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE,
//  AND OF GOOD TITLE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
//  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
//  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
//  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
//  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
//  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
//  OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
//  ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
////////////////////////////////////////////////////////////////////////////////
//
//  DO NOT EDIT
//
//  Add a category or subclass in separate .h/.m files to extend these classes
//
////////////////////////////////////////////////////////////////////////////////
//
//  AJNFileTransferBusObject.h
//
////////////////////////////////////////////////////////////////////////////////

#import <Foundation/Foundation.h>
#import "AllJoynFramework/AJNBusAttachment.h"
#import "AllJoynFramework/AJNBusInterface.h"
#import "AllJoynFramework/AJNProxyBusObject.h"


////////////////////////////////////////////////////////////////////////////////
//
// DataTransferDelegate Bus Interface
//
////////////////////////////////////////////////////////////////////////////////

@protocol DataTransferDelegate <AJNBusInterface>


// methods
//
- (NSNumber*)requestDataWithFileID:(AJNMessageArgument*)fileID startByte:(NSNumber*)startByte length:(NSNumber*)length andMaxChunkLength:(NSNumber*)maxChunkLength fromSender:(NSString *)sender;

// signals
//
- (void)sendDataChunkWithFileID:(AJNMessageArgument*)fileID startByte:(NSNumber*)startByte length:(NSNumber*)chunkLength andFileChunk:(AJNMessageArgument*)chunk inSession:(AJNSessionId)sessionId toDestination:(NSString*)destinationPath;
- (void)sendStopDataXferWithFileID:(AJNMessageArgument*)fileID inSession:(AJNSessionId)sessionId toDestination:(NSString*)destinationPath;
- (void)sendDataXferCancelledWithFileID:(AJNMessageArgument*)fileID inSession:(AJNSessionId)sessionId toDestination:(NSString*)destinationPath;


@end

////////////////////////////////////////////////////////////////////////////////

    
////////////////////////////////////////////////////////////////////////////////
//
// DataTransferDelegate Signal Handler Protocol
//
////////////////////////////////////////////////////////////////////////////////

@protocol DataTransferDelegateSignalHandler <AJNSignalHandler>

// signals
//
- (void)didReceiveDataChunkWithFileID:(AJNMessageArgument*)fileID startByte:(NSNumber*)startByte length:(NSNumber*)chunkLength andFileChunk:(AJNMessageArgument*)chunk inSession:(AJNSessionId)sessionId fromSender:(NSString*)sender;
- (void)didReceiveStopDataXferWithFileID:(AJNMessageArgument*)fileID inSession:(AJNSessionId)sessionId fromSender:(NSString*)sender;
- (void)didReceiveDataXferCancelledWithFileID:(AJNMessageArgument*)fileID inSession:(AJNSessionId)sessionId fromSender:(NSString*)sender;


@end

@interface AJNBusAttachment(DataTransferDelegate)

- (void)registerDataTransferDelegateSignalHandler:(id<DataTransferDelegateSignalHandler>)signalHandler;

@end

////////////////////////////////////////////////////////////////////////////////
    

////////////////////////////////////////////////////////////////////////////////
//
// FileDiscoveryDelegate Bus Interface
//
////////////////////////////////////////////////////////////////////////////////

@protocol FileDiscoveryDelegate <AJNBusInterface>


// methods
//
- (NSNumber*)requestOfferWithFilePath:(NSString*)filePath fromSender:(NSString *)sender;
- (NSNumber*)offerFileWithFileDescriptor:(AJNMessageArgument*)file fromSender:(NSString *)sender;

// signals
//
- (void)sendAnnounceWithFileList:(AJNMessageArgument*)fileList andIsFileIDResponse:(BOOL)isFileIDResponse inSession:(AJNSessionId)sessionId toDestination:(NSString*)destinationPath;
- (void)sendrequestAnnouncementInSession:(AJNSessionId)sessionId toDestination:(NSString*)destinationPath;


@end

////////////////////////////////////////////////////////////////////////////////

    
////////////////////////////////////////////////////////////////////////////////
//
// FileDiscoveryDelegate Signal Handler Protocol
//
////////////////////////////////////////////////////////////////////////////////

@protocol FileDiscoveryDelegateSignalHandler <AJNSignalHandler>

// signals
//
- (void)didReceiveAnnounceWithFileList:(AJNMessageArgument*)fileList andIsFileIDResponse:(BOOL)isFileIDResponse inSession:(AJNSessionId)sessionId fromSender:(NSString*)sender;
- (void)didReceiverequestAnnouncementInSession:(AJNSessionId)sessionId fromSender:(NSString*)sender;


@end

@interface AJNBusAttachment(FileDiscoveryDelegate)

- (void)registerFileDiscoveryDelegateSignalHandler:(id<FileDiscoveryDelegateSignalHandler>)signalHandler;

@end

////////////////////////////////////////////////////////////////////////////////
    

////////////////////////////////////////////////////////////////////////////////
//
//  AJNFileTransferBusObject Bus Object superclass
//
////////////////////////////////////////////////////////////////////////////////

@interface AJNFileTransferBusObject : AJNBusObject<DataTransferDelegate, FileDiscoveryDelegate>

// properties
//


// methods
//
- (NSNumber*)requestDataWithFileID:(AJNMessageArgument*)fileID startByte:(NSNumber*)startByte length:(NSNumber*)length andMaxChunkLength:(NSNumber*)maxChunkLength fromSender:(NSString *)sender;
- (NSNumber*)requestOfferWithFilePath:(NSString*)filePath fromSender:(NSString *)sender;
- (NSNumber*)offerFileWithFileDescriptor:(AJNMessageArgument*)file fromSender:(NSString *)sender;


// signals
//
- (void)sendDataChunkWithFileID:(AJNMessageArgument*)fileID startByte:(NSNumber*)startByte length:(NSNumber*)chunkLength andFileChunk:(AJNMessageArgument*)chunk inSession:(AJNSessionId)sessionId toDestination:(NSString*)destinationPath;
- (void)sendStopDataXferWithFileID:(AJNMessageArgument*)fileID inSession:(AJNSessionId)sessionId toDestination:(NSString*)destinationPath;
- (void)sendDataXferCancelledWithFileID:(AJNMessageArgument*)fileID inSession:(AJNSessionId)sessionId toDestination:(NSString*)destinationPath;
- (void)sendAnnounceWithFileList:(AJNMessageArgument*)fileList andIsFileIDResponse:(BOOL)isFileIDResponse inSession:(AJNSessionId)sessionId toDestination:(NSString*)destinationPath;
- (void)sendrequestAnnouncementInSession:(AJNSessionId)sessionId toDestination:(NSString*)destinationPath;


@end

////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
//
//  FileTransferBusObject Proxy
//
////////////////////////////////////////////////////////////////////////////////

@interface FileTransferBusObjectProxy : AJNProxyBusObject

// properties
//


// methods
//
- (NSNumber*)requestDataWithFileID:(AJNMessageArgument*)fileID startByte:(NSNumber*)startByte length:(NSNumber*)length andMaxChunkLength:(NSNumber*)maxChunkLength;
- (NSNumber*)requestOfferWithFilePath:(NSString*)filePath;
- (NSNumber*)offerFileWithFileDescriptor:(AJNMessageArgument*)file;


@end

////////////////////////////////////////////////////////////////////////////////
